local windowOpen = ui_imgui.BoolPtr(true)

local M = {}
M.dependencies = {"ui_imgui"}
local im = ui_imgui

local lightObjectGroups = {"lights_group_west", "lights_group_middle", "lights_group_east"}
local lightObjectState = {true, true, true}

local function setHiddenRec(object, hidden)
  object.hidden = hidden
  if object:isSubClassOf("SimSet") then
    for i=0, object:size() - 1 do
      setHiddenRec(object:at(i), hidden)
    end
  end
end

local function hideGroup(groupName, hidden)
  local group = scenetree.findObject(groupName)
  if group then setHiddenRec(group, hidden) end
end

local function toggleLighting(lineId)
  if lightObjectState[lineId] == true then
    hideGroup(lightObjectGroups[lineId], true)
    lightObjectState[lineId] = false
  elseif lightObjectState[lineId] == false then
    hideGroup(lightObjectGroups[lineId], false)
    lightObjectState[lineId] = true
  end
end

local function onUpdate()
  im.Begin("Garage Map Controller - garage_v2_vibe", nil)
    im.Text("Toggle Lights")
    if im.Button("Lights West") then
      toggleLighting(1)
    end
    im.SameLine()
    if im.Button("Lights Middle") then
      toggleLighting(2)
    end
    im.SameLine()
    if im.Button("Lights East") then
      toggleLighting(3)
    end
  im.End()
end

M.onUpdate = onUpdate

return M 